<template>
	<div>
		<h1>Stocks (US only)</h1>
		<v-autocomplete
			v-model="selectedStock"
			:items="allAvailableStocks"
			hide-details
			hide-selected
			item-text="description"
			item-value="symbol"
			label="Search for a stock ..."
			no-data-text="No stock found"
			solo
			class="mt-3 mb-7"
			:loading="loadingAllAvailableStocks"
			:disabled="loadingAllAvailableStocks"
			@change="fetchStockInformation"
		/>
		<v-row v-if="companies.length > 0">
			<v-col
				v-for="company in companies"
				:key="company.ticker"
				cols="4"
			>
				<app-card
					:company="company"
					:loading="loadingStockInformation"
					@remove-from-search-list="remove"
				/>
			</v-col>
		</v-row>
	</div>
</template>

<script>
import eventBus from '@/util/eventBus';
import finnhubClient from '@/plugins/finnhubClient';
import Card from '@/components/stocks/Card';

export default {
	components: {
		appCard: Card,
	},
	data() {
		return {
			selectedStock: null,
			loadingAllAvailableStocks: false,
			loadingStockInformation: false,
			companies: [],
		}
	},
	created() {
		eventBus.$on('loadingAllAvailableStocks', loading => this.loadingAllAvailableStocks = loading);
	},
	computed: {
		allAvailableStocks() {
			return this.$store.getters['stocks/allAvailableStocks'];
		},
	},
	methods: {
		fetchStockInformation() {
			this.loadingStockInformation = true;
			
			finnhubClient.companyProfile2({ symbol: this.selectedStock }, (e, companyProfile, r) => {
				if (e !== null) {
					console.log(e);
					return;
				}

				finnhubClient.quote(this.selectedStock, (e, candlePrices, r) => {
					if (e !== null) {
						console.log(e);
						return;
					}

					companyProfile.price = candlePrices;

					const inCompanies = this.companies.find(company => company.ticker === companyProfile.ticker);
					if (!inCompanies) {
						this.companies.push(companyProfile);	
					}

					this.loadingStockInformation = false;
				});
			});
		},
		remove(ticker) {

			this.companies.forEach((company, i) => {
				if (company.ticker === ticker) {
					this.companies.splice(i, 1);
					return;
				}
			});
		},
	},
};
</script>
